#!/usr/bin/ruby

require 'metasm'

src = <<EOS
void printf(char *, ...);
void gets(char*);

char pass[] = "hfhllili";

void decode_pass(char *p) {
	while (*p)
		*p++ += 3;
}

void prompt_pass(char *p) {
	gets(p);
}

int main(void) {
	char ans[256];
	char *p = pass;
	int isgood = 1;

	decode_pass(pass);
	printf("What is the password ?\\n");
	prompt_pass(ans);

	for (int i=0 ; i<sizeof(ans) ; ++i) {
		if (ans[i] == '\\n' || ans[i] == '\\r')
			ans[i] = 0;
		if (ans[i] != p[i])
			isgood = 0;
		if (!p[i])
			break;
	}

	if (isgood)
		printf("Good pass !\\n");
	else
		printf("Bad pass !\\n");
	
	return 0;
}
EOS

Metasm::ELF.compile_c(Metasm::X64.new, src).encode_file('pass.bin')
Metasm::ELF.compile_c(Metasm::Ia32.new, src).encode_file('pass32.bin')
Metasm::PE.compile_c(Metasm::X64.new, src).encode_file('pass.exe')

