#!/usr/bin/env ruby

require 'metasm'
include Metasm

# patch the control flow by hooking the resolution of the jmp eax target

# load the binary
file = 'grimcreeper.d'
ep = 'parse_options'

e = AutoExe.decode_file(file)
dasm = e.disassembler

# setup a disassembler callback
dasm.callback_newaddr = lambda { |orig, target|
	# this lambda called for every new adress found by the disassembler

	# check that we are at the right instruction

	# retrieve the switch table content
	switch_entries = []
	6.times { |nr|
	}

	# return the values
	switch_entries
}

# now that the hook is in place, we can start to disassemble
dasm.disassemble(ep)

# run the gui to check the results
Gui::DasmWindow.new("metasm disassembler - #{file}", dasm, ep)
Gui.main



