#!/usr/bin/env ruby

$: << '/path/to/metasm' # optional path to metasm
require 'metasm'  # load metasm
include Metasm    # avoid Metasm::Bla

file = 'crackme_nop_vm.exe'
e = AutoExe.decode_file(file)
d = e.disassembler

ep = 0x40137c
d.disassemble_fast_deep(ep)

Gui::DasmWindow.new("metasm disassembler - #{file}", d, ep)
d.load_plugin('hl_opcode')
Gui.main
