#!/usr/bin/env ruby

$: << '/path/to/metasm'	# put the path to metasm here (or in the RUBYLIB environment variable)

require 'metasm'
include Metasm

$VERBOSE = true		# show what going on

# load the grimcreeper.d binary in the disassembler
file = 'grimcreeper.d'
exe = AutoExe.decode_file(file)
dasm = exe.disassembler

# load the gui, disassemble from 'entrypoint'
Gui::DasmWindow.new("metasm disassembler - #{file}", dasm, 'entrypoint')
dasm.load_plugin 'hl_opcode'	# load the 'highlight opcodes' GUI plugin
Gui.main	# main loop
