require 'metasm'
require File.expand_path('../vm_cpu', __FILE__)
include Metasm

ep = 0x40121D

pe = AutoExe.decode_file('crackme_nop_vm.exe')
pe.cpu = VM_CPU.new

d = pe.disassembler

labels = {
	0x4014E8 => 'thunk_ExitProcess',
	0x4014EE => 'thunk_GetStdHandle',
	0x4014F4 => 'thunk_ReadFile',
	0x4014FA => 'thunk_Sleep',
	0x401500 => 'thunk_WriteFile',
	0x403000 => 'pass_buffer',
}

labels.each { |a, n| d.set_label_at(a, n) }

d.disassemble(ep)

Gui::DasmWindow.new("vm dasm", d, ep)
Gui.main
