#!/usr/bin/ruby

require 'metasm'

dbg = Metasm::OS.current.create_process('./pass32.bin').debugger

base = nil
dbg.modules.each { |m|
	if m.path =~ /pass.*.bin/
		base = m.addr
	end
}

#dbg.bpx(base + 0x246) {
#	puts "HAX"
#	dbg.pc = base + 0x301
#}

debut_str = nil
dbg.bpx(base + 0x21f) {
	ptr = dbg.resolve('ecx')
	puts "buffer at %x" % ptr
	dbg.stepover_wait
	dbg.stepover_wait
	puts 'password: %s' % dbg.dasm.decode_strz(ptr)
}

dbg.run_forever
