#!/usr/bin/ruby

require 'metasm'

dbg = Metasm::OS.current.create_process('./pass.bin').debugger

base_addr = nil
dbg.modules.each { |m| base_addr = m.addr if m.path =~ /pass/ }
raise 'cannot find base addr?' if not base_addr

dbg.bpx(base_addr + 0x2bc) {
	puts "BP hit ! [eax] = #{'%c' % dbg.resolve("byte ptr [rax]")}"
}

dbg.run_forever
