#!/usr/bin/ruby

require 'metasm'

bin = Metasm::AutoExe.decode_file('./true')

dasm = bin.disassembler

#dasm.callback_newaddr = lambda { |addr_origin, list|
#	if addr_origin == 0x4014cd and Metasm::Expression[list[0]].reduce == 0x4014cf
#		[]
#	else
#		list
#	end
#}

dasm.disassemble('section__text')

dasm.each_xref(Metasm::Expression['thunk_dcgettext']) { |xr|
	addr = dasm.backtrace(Metasm::Expression[:rsi], xr.origin)[0]
	addr = Metasm::Expression[addr].reduce
	if addr.kind_of?(Integer)
		p dasm.decode_strz(addr)
	end
}

Metasm::Gui::DasmWindow.new("titre", dasm, ['section__text'])

Metasm::Gui.main
